Bug 491088 - (rhncfg) Review Request: rhncfg - Red Hat Network Configuration Client Libraries
Review Request: rhncfg - Red Hat Network Configuration Client Libraries
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Sandro Mathys
Fedora Extras Quality Assurance
:
Depends On: rhn-client-tools
Blocks: F-Spacewalk
  Show dependency treegraph
 
Reported: 2009-03-19 08:57 EDT by Miroslav Suchý
Modified: 2009-11-20 05:40 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-11-20 05:40:18 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
sandro: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Miroslav Suchý 2009-03-19 08:57:24 EDT
SPEC: http://miroslav.suchy.cz/fedora/rhncfg/rhncfg.spec
SRPM: http://miroslav.suchy.cz/fedora/rhncfg/rhncfg-5.9.4-1.src.rpm

Description:
Red Hat Network Configuration Client Libraries

Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=1249796

Rpmlint is silent but:
# rpmlint /tmp/spacewalk-build/rpmbuild-rhncfg-5.9.4-1/noarch/rhncfg-5.9.4-1.noarch.rpm
rhncfg.noarch: E: explicit-lib-dependency rhnlib

But without this explicit dependency - the dependency is not picked up using automatic depsolver.
Comment 1 Sandro Mathys 2009-09-21 11:08:54 EDT
no review, just some remarks:

- I'm sure you can do better with all the %description
- make is missing build-flags
- use %global instead of %define:
http://fedoraproject.org/wiki/Packaging/Guidelines#.25global_preferred_over_.25define
Comment 2 Miroslav Suchý 2009-11-17 06:24:27 EST
Updated SPEC:
http://miroslav.suchy.cz/fedora/rhncfg/rhncfg.spec
Update SRPM:
http://miroslav.suchy.cz/fedora/rhncfg/rhncfg-5.9.13-1.src.rpm

Not sure what you meant by "make is missing build-flags" - do you meant compiler flags? This is noarch package...
Comment 3 Sandro Mathys 2009-11-17 13:58:08 EST
That's exactly what I meant. I missed the noarch instruction, you're right, of course.
Comment 4 Sandro Mathys 2009-11-17 16:10:33 EST
NEEDSWORK - MUST: rpmlint must be run on every package. The output should be posted in the review.

$ rpmlint {SPECS,RPMS/noarch,SRPMS}/rhncfg*
rhncfg.noarch: E: explicit-lib-dependency libselinux-python
rhncfg.noarch: E: explicit-lib-dependency rhnlib
rhncfg.noarch: E: explicit-lib-dependency rhnlib
10 packages and 1 specfiles checked; 3 errors, 0 warnings.

rhnlib seems to be a special case and you can ignore those warning, but please remove libselinux-python.

OK - MUST: The package must be named according to the Package Naming Guidelines.
OK - MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. .
OK - MUST: The package must meet the Packaging Guidelines.
OK - MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
NEEDSWORK - MUST: The License field in the package spec file must match the actual license.

License should be "GPLv2 and Python" (e.g. compile.py is based on Python-licensed code) - asked spot about this to be sure.

NEEDSWORK -  MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

PYTHON-LICENSES.txt should be added to %doc

OK - MUST: The spec file must be written in American English.
OK - MUST: The spec file for the package MUST be legible.
OK - MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task.  If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

$ md5sum rhncfg-5.9.13.tar.gz SOURCES/rhncfg-5.9.13.tar.gz
71374b0b5a61b32affc762079d1b688b  rhncfg-5.9.13.tar.gz
71374b0b5a61b32affc762079d1b688b  SOURCES/rhncfg-5.9.13.tar.gz

OK - MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
N/A - MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
OK - MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
N/A - MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
N/A - MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
OK - MUST: Packages must NOT bundle copies of system libraries.
N/A - MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
NEEDSWORK - MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.

%{rhnroot} (i.e. %{_datadir}/rhn) is used in every package but rhn-client-tools is only required in rhncfg-actions. This require should be moved up to the main package.
%{rhnconf} (i.e. %_sysconfdir}/sysconfig/rhn) is used in the client and management subpackages which is to be found in rhn-client-tools as well.

OK - MUST: A Fedora package must not list a file more than once in the spec file's %files listings.
OK - MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
OK - MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
OK - MUST: Each package must consistently use macros.
OK - MUST: The package must contain code, or permissable content.
N/A - MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
OK - MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
N/A - MUST: Header files must be in a -devel package.
N/A - MUST: Static libraries must be in a -static package.
N/A - MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
N/A - MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
N/A - MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
N/A - MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
N/A - MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
OK - MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
OK - MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
OK - MUST: All filenames in rpm packages must be valid UTF-8.
N/A - SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
N/A - SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
OK - SHOULD: The reviewer should test that the package builds in mock.
OK - SHOULD: The package should compile and build into binary rpms on all supported architectures.
N/A - SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
N/A - SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
OK - SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
N/A - SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg.  A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
N/A - SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.

Some more remarks from my side:
- IMHO you shouldn't repeat the summary in the description. And the 'A' or 'The' at the beginning of the description can be removed as well as it doesn't matter whether it's one-of-many or the-only-one package doing something (and this might change in future anyway). Both are no blocker, tho.
- I wasn't sure if the 'Provides:' in the spec file are sane so I asked some more experienced guys (thm and rsc from #fedora-de) about them. Fact is that provides only make sense if the provided package is obsoleted in the same package which isn't the case here. Therefore please remove all provides from the spec file unless you have a proper explanation for them. As a side note: even if the provides were sane, no two packages (i.e. base and subpackage) should ever feature the same provides.

Fix those tiny bits and we should be ready to get this into Fedora :)
Comment 5 Miroslav Suchý 2009-11-18 04:07:13 EST
> rhnlib seems to be a special case and you can ignore those warning
yes, it is special case

> but please remove libselinux-python.
I would like, but if I remove it, it is not included. I build test package with that Requirese: removed and got:
$ rpm -qpR /tmp/spacewalk-build/rpmbuild-rhncfg-git-c9cd2e0cf23a7bd6eaed93435c305d7b1c975378/noarch/rhncfg-5.9.13-1.git.c9cd2e0cf23a7bd6eaed93435c305d7b1c975378.noarch.rpm
python
rhnlib
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(VersionedDependencies) <= 3.0.3-1

> License should be "GPLv2 and Python" (e.g. compile.py is based on
> Python-licensed code) - asked spot about this to be sure
Did not know. Done.

> PYTHON-LICENSES.txt should be added to %doc
Done

> This require should be moved up to the main package.
Done.

> Therefore please remove all provides from
> the spec file unless you have a proper explanation for them.
Old heritage. I tracked it to year 2003 and could not find reason, why it has been added. Dropped.
Comment 7 Sandro Mathys 2009-11-18 05:09:37 EST
All issues have been correctly addressed.

-------------------------------------------------------------
   This package (rhncfg) is APPROVED by red (Sandro Mathys)
-------------------------------------------------------------
Comment 8 Miroslav Suchý 2009-11-18 05:23:06 EST
New Package CVS Request
=======================
Package Name: rhncfg
Short Description: Red Hat Network Configuration Client Libraries
Owners: msuchy
Branches: F-11, F-12
InitialCC:
Comment 9 Jason Tibbitts 2009-11-19 13:05:44 EST
How did this ticket get all the way to CVS without being assigned to anyone?  Please folks, at least take a ticket when you're going to review it.

CVS done.

Note You need to log in before you can comment on or make changes to this bug.